diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/core/model/log.cc ns-3.38/src/core/model/log.cc
--- ns-3.37/src/core/model/log.cc	2022-11-01 17:37:24.471395000 -0700
+++ ns-3.38/src/core/model/log.cc	2023-03-16 20:54:23.592868600 -0700
@@ -19,14 +19,19 @@
 #include "log.h"
 
 #include "assert.h"
+#include "environment-variable.h"
 #include "fatal-error.h"
+#include "string.h"
 
 #include "ns3/core-config.h"
 
-#include <cstdlib> // getenv
-#include <cstring> // strlen
+#include <algorithm> // transform
+#include <cstring>   // strlen
 #include <iostream>
 #include <list>
+#include <locale> // toupper
+#include <map>
+#include <numeric> // accumulate
 #include <stdexcept>
 #include <utility>
 
@@ -36,6 +41,65 @@
  * ns3::LogComponent and related implementations.
  */
 
+/**
+ * \ingroup logging
+ * Unnamed namespace for log.cc
+ */
+namespace
+{
+/** Mapping of log level text names to values. */
+const std::map<std::string, ns3::LogLevel> LOG_LABEL_LEVELS = {
+    // clang-format off
+        {"none",           ns3::LOG_NONE},
+        {"error",          ns3::LOG_ERROR},
+        {"level_error",    ns3::LOG_LEVEL_ERROR},
+        {"warn",           ns3::LOG_WARN},
+        {"level_warn",     ns3::LOG_LEVEL_WARN},
+        {"debug",          ns3::LOG_DEBUG},
+        {"level_debug",    ns3::LOG_LEVEL_DEBUG},
+        {"info",           ns3::LOG_INFO},
+        {"level_info",     ns3::LOG_LEVEL_INFO},
+        {"function",       ns3::LOG_FUNCTION},
+        {"level_function", ns3::LOG_LEVEL_FUNCTION},
+        {"logic",          ns3::LOG_LOGIC},
+        {"level_logic",    ns3::LOG_LEVEL_LOGIC},
+        {"all",            ns3::LOG_ALL},
+        {"level_all",      ns3::LOG_LEVEL_ALL},
+        {"func",           ns3::LOG_PREFIX_FUNC},
+        {"prefix_func",    ns3::LOG_PREFIX_FUNC},
+        {"time",           ns3::LOG_PREFIX_TIME},
+        {"prefix_time",    ns3::LOG_PREFIX_TIME},
+        {"node",           ns3::LOG_PREFIX_NODE},
+        {"prefix_node",    ns3::LOG_PREFIX_NODE},
+        {"level",          ns3::LOG_PREFIX_LEVEL},
+        {"prefix_level",   ns3::LOG_PREFIX_LEVEL},
+        {"prefix_all",     ns3::LOG_PREFIX_ALL}
+    // clang-format on
+};
+
+/** Inverse mapping of level values to log level text names. */
+const std::map<ns3::LogLevel, std::string> LOG_LEVEL_LABELS = {[]() {
+    std::map<ns3::LogLevel, std::string> labels;
+    for (const auto& [label, lev] : LOG_LABEL_LEVELS)
+    {
+        // Only keep the first label for a level
+        if (labels.find(lev) == labels.end())
+        {
+            std::string pad{label};
+            // Add whitespace for alignment with "ERROR", "DEBUG" etc.
+            if (pad.size() < 5)
+            {
+                pad.insert(pad.size(), 5 - pad.size(), ' ');
+            }
+            std::transform(pad.begin(), pad.end(), pad.begin(), ::toupper);
+            labels[lev] = pad;
+        }
+    }
+    return labels;
+}()};
+
+} // Unnamed namespace
+
 namespace ns3
 {
 
@@ -53,8 +117,13 @@
 
 /**
  * \ingroup logging
- * Handler for \c print-list token in NS_LOG
- * to print the list of log components.
+ * Handler for the undocumented \c print-list token in NS_LOG
+ * which triggers printing of the list of log components, then exits.
+ *
+ * A static instance of this class is instantiated below, so the
+ * \c print-list token is handled before any other logging action
+ * can take place.
+ *
  * This is private to the logging implementation.
  */
 class PrintList
@@ -79,36 +148,23 @@
 
 PrintList::PrintList()
 {
-    const char* envVar = std::getenv("NS_LOG");
-    if (envVar == nullptr || std::strlen(envVar) == 0)
+    auto [found, value] = EnvironmentVariable::Get("NS_LOG", "print-list", ":");
+    if (found)
     {
-        return;
-    }
-    std::string env = envVar;
-    std::string::size_type cur = 0;
-    std::string::size_type next = 0;
-    while (next != std::string::npos)
-    {
-        next = env.find_first_of(':', cur);
-        std::string tmp = std::string(env, cur, next - cur);
-        if (tmp == "print-list")
-        {
-            LogComponentPrintList();
-            exit(0);
-            break;
-        }
-        cur = next + 1;
+        LogComponentPrintList();
+        exit(0);
     }
 }
 
 LogComponent::LogComponent(const std::string& name,
                            const std::string& file,
-                           const enum LogLevel mask /* = 0 */)
+                           const LogLevel mask /* = 0 */)
     : m_levels(0),
       m_mask(mask),
       m_name(name),
       m_file(file)
 {
+    // Check if we're mentioned in NS_LOG, and set our flags appropriately
     EnvVarCheck();
 
     LogComponent::ComponentList* components = GetComponentList();
@@ -144,139 +200,54 @@
 void
 LogComponent::EnvVarCheck()
 {
-    const char* envVar = std::getenv("NS_LOG");
-    if (envVar == nullptr || std::strlen(envVar) == 0)
+    auto [found, value] = EnvironmentVariable::Get("NS_LOG", m_name, ":");
+    if (!found)
+    {
+        std::tie(found, value) = EnvironmentVariable::Get("NS_LOG", "*", ":");
+    }
+    if (!found)
+    {
+        std::tie(found, value) = EnvironmentVariable::Get("NS_LOG", "***", ":");
+    }
+
+    if (!found)
     {
         return;
     }
-    std::string env = envVar;
 
-    std::string::size_type cur = 0;
-    std::string::size_type next = 0;
-    while (next != std::string::npos)
-    {
-        next = env.find_first_of(':', cur);
-        std::string tmp = std::string(env, cur, next - cur);
-        std::string::size_type equal = tmp.find('=');
-        std::string component;
-        if (equal == std::string::npos)
-        {
-            component = tmp;
-            if (component == m_name || component == "*" || component == "***")
-            {
-                int level = LOG_LEVEL_ALL | LOG_PREFIX_ALL;
-                Enable((enum LogLevel)level);
-                return;
-            }
-        }
-        else
-        {
-            component = tmp.substr(0, equal);
-            if (component == m_name || component == "*")
-            {
-                int level = 0;
-                std::string::size_type cur_lev;
-                std::string::size_type next_lev = equal;
-                bool pre_pipe = true; // before the first '|', enables positional 'all', '*'
-                do
-                {
-                    cur_lev = next_lev + 1;
-                    next_lev = tmp.find('|', cur_lev);
-                    std::string lev = tmp.substr(cur_lev, next_lev - cur_lev);
-                    if (lev == "error")
-                    {
-                        level |= LOG_ERROR;
-                    }
-                    else if (lev == "warn")
-                    {
-                        level |= LOG_WARN;
-                    }
-                    else if (lev == "debug")
-                    {
-                        level |= LOG_DEBUG;
-                    }
-                    else if (lev == "info")
-                    {
-                        level |= LOG_INFO;
-                    }
-                    else if (lev == "function")
-                    {
-                        level |= LOG_FUNCTION;
-                    }
-                    else if (lev == "logic")
-                    {
-                        level |= LOG_LOGIC;
-                    }
-                    else if (pre_pipe && ((lev == "all") || (lev == "*")))
-                    {
-                        level |= LOG_LEVEL_ALL;
-                    }
-                    else if ((lev == "prefix_func") || (lev == "func"))
-                    {
-                        level |= LOG_PREFIX_FUNC;
-                    }
-                    else if ((lev == "prefix_time") || (lev == "time"))
-                    {
-                        level |= LOG_PREFIX_TIME;
-                    }
-                    else if ((lev == "prefix_node") || (lev == "node"))
-                    {
-                        level |= LOG_PREFIX_NODE;
-                    }
-                    else if ((lev == "prefix_level") || (lev == "level"))
-                    {
-                        level |= LOG_PREFIX_LEVEL;
-                    }
-                    else if ((lev == "prefix_all") ||
-                             (!pre_pipe && ((lev == "all") || (lev == "*"))))
-                    {
-                        level |= LOG_PREFIX_ALL;
-                    }
-                    else if (lev == "level_error")
-                    {
-                        level |= LOG_LEVEL_ERROR;
-                    }
-                    else if (lev == "level_warn")
-                    {
-                        level |= LOG_LEVEL_WARN;
-                    }
-                    else if (lev == "level_debug")
-                    {
-                        level |= LOG_LEVEL_DEBUG;
-                    }
-                    else if (lev == "level_info")
-                    {
-                        level |= LOG_LEVEL_INFO;
-                    }
-                    else if (lev == "level_function")
-                    {
-                        level |= LOG_LEVEL_FUNCTION;
-                    }
-                    else if (lev == "level_logic")
-                    {
-                        level |= LOG_LEVEL_LOGIC;
-                    }
-                    else if (lev == "level_all")
-                    {
-                        level |= LOG_LEVEL_ALL;
-                    }
-                    else if (lev == "**")
-                    {
-                        level |= LOG_LEVEL_ALL | LOG_PREFIX_ALL;
-                    }
+    if (value.empty())
+    {
+        // Default is enable all levels, all prefixes
+        value = "**";
+    }
 
-                    pre_pipe = false;
-                } while (next_lev != std::string::npos);
+    // Got a value, might have flags
+    int level = 0;
+    StringVector flags = SplitString(value, "|");
+    NS_ASSERT_MSG(!flags.empty(), "Unexpected empty flags from non-empty value");
+    bool pre_pipe{true};
 
-                Enable((enum LogLevel)level);
-            }
+    for (const auto& lev : flags)
+    {
+        if (lev == "**")
+        {
+            level |= LOG_LEVEL_ALL | LOG_PREFIX_ALL;
         }
-        cur = next + 1;
+        else if (lev == "all" || lev == "*")
+        {
+            level |= (pre_pipe ? LOG_LEVEL_ALL : LOG_PREFIX_ALL);
+        }
+        else if (LOG_LABEL_LEVELS.find(lev) != LOG_LABEL_LEVELS.end())
+        {
+            level |= LOG_LABEL_LEVELS.at(lev);
+        }
+        pre_pipe = false;
     }
+    Enable((LogLevel)level);
 }
 
 bool
-LogComponent::IsEnabled(const enum LogLevel level) const
+LogComponent::IsEnabled(const LogLevel level) const
 {
     //  LogComponentEnableEnvVar ();
     return (level & m_levels) ? 1 : 0;
@@ -289,27 +260,27 @@
 }
 
 void
-LogComponent::SetMask(const enum LogLevel level)
+LogComponent::SetMask(const LogLevel level)
 {
     m_mask |= level;
 }
 
 void
-LogComponent::Enable(const enum LogLevel level)
+LogComponent::Enable(const LogLevel level)
 {
     m_levels |= (level & ~m_mask);
 }
 
 void
-LogComponent::Disable(const enum LogLevel level)
+LogComponent::Disable(const LogLevel level)
 {
     m_levels &= ~level;
 }
 
-const char*
+std::string
 LogComponent::Name() const
 {
-    return m_name.c_str();
+    return m_name;
 }
 
 std::string
@@ -320,42 +291,18 @@
 
 /* static */
 std::string
-LogComponent::GetLevelLabel(const enum LogLevel level)
+LogComponent::GetLevelLabel(const LogLevel level)
 {
-    if (level == LOG_ERROR)
+    auto it = LOG_LEVEL_LABELS.find(level);
+    if (it != LOG_LEVEL_LABELS.end())
     {
-        return "ERROR";
-    }
-    else if (level == LOG_WARN)
-    {
-        // whitespace left at the end for alignment
-        return "WARN ";
-    }
-    else if (level == LOG_DEBUG)
-    {
-        return "DEBUG";
-    }
-    else if (level == LOG_INFO)
-    {
-        // whitespace left at the end for alignment
-        return "INFO ";
-    }
-    else if (level == LOG_FUNCTION)
-    {
-        return "FUNCT";
-    }
-    else if (level == LOG_LOGIC)
-    {
-        return "LOGIC";
-    }
-    else
-    {
-        return "unknown";
+        return it->second;
     }
+    return "unknown";
 }
 
 void
-LogComponentEnable(const char* name, enum LogLevel level)
+LogComponentEnable(const std::string& name, LogLevel level)
 {
     LogComponent::ComponentList* components = LogComponent::GetComponentList();
     LogComponent::ComponentList::const_iterator i;
@@ -370,14 +317,16 @@
     if (i == components->end())
     {
         // nothing matched
+        NS_LOG_UNCOND("Logging component \"" << name << "\" not found.");
         LogComponentPrintList();
         NS_FATAL_ERROR("Logging component \""
-                       << name << "\" not found. See above for a list of available log components");
+                       << name << "\" not found."
+                       << " See above for a list of available log components");
     }
 }
 
 void
-LogComponentEnableAll(enum LogLevel level)
+LogComponentEnableAll(LogLevel level)
 {
     LogComponent::ComponentList* components = LogComponent::GetComponentList();
     for (LogComponent::ComponentList::const_iterator i = components->begin();
@@ -389,7 +338,7 @@
 }
 
 void
-LogComponentDisable(const char* name, enum LogLevel level)
+LogComponentDisable(const std::string& name, LogLevel level)
 {
     LogComponent::ComponentList* components = LogComponent::GetComponentList();
     for (LogComponent::ComponentList::const_iterator i = components->begin();
@@ -405,7 +354,7 @@
 }
 
 void
-LogComponentDisableAll(enum LogLevel level)
+LogComponentDisableAll(LogLevel level)
 {
     LogComponent::ComponentList* components = LogComponent::GetComponentList();
     for (LogComponent::ComponentList::const_iterator i = components->begin();
@@ -499,12 +448,11 @@
 static bool
 ComponentExists(std::string componentName)
 {
-    const char* name = componentName.c_str();
     LogComponent::ComponentList* components = LogComponent::GetComponentList();
     LogComponent::ComponentList::const_iterator i;
     for (i = components->begin(); i != components->end(); i++)
     {
-        if (i->first == name)
+        if (i->first == componentName)
         {
             return true;
         }
@@ -522,81 +470,42 @@
 static void
 CheckEnvironmentVariables()
 {
-    const char* envVar = std::getenv("NS_LOG");
-    if (envVar == nullptr || std::strlen(envVar) == 0)
-    {
-        return;
-    }
+    auto dict = EnvironmentVariable::GetDictionary("NS_LOG", ":")->GetStore();
 
-    std::string env = envVar;
-    std::string::size_type cur = 0;
-    std::string::size_type next = 0;
-
-    while (next != std::string::npos)
-    {
-        next = env.find_first_of(':', cur);
-        std::string tmp = std::string(env, cur, next - cur);
-        std::string::size_type equal = tmp.find('=');
-        std::string component;
-        if (equal == std::string::npos)
-        {
-            // ie no '=' characters found
-            component = tmp;
-            if (ComponentExists(component) || component == "*" || component == "***")
-            {
-                return;
-            }
-            else
-            {
-                LogComponentPrintList();
-                NS_FATAL_ERROR(
-                    "Invalid or unregistered component name \""
-                    << component
-                    << "\" in env variable NS_LOG, see above for a list of valid components");
-            }
+    for (auto& [component, value] : dict)
+    {
+        if (component != "*" && component != "***" && !ComponentExists(component))
+        {
+            NS_LOG_UNCOND("Invalid or unregistered component name \"" << component << "\"");
+            LogComponentPrintList();
+            NS_FATAL_ERROR(
+                "Invalid or unregistered component name \""
+                << component
+                << "\" in env variable NS_LOG, see above for a list of valid components");
         }
-        else
+
+        // We have a valid component or wildcard, check the flags
+        if (!value.empty())
         {
-            component = tmp.substr(0, equal);
-            if (ComponentExists(component) || component == "*")
+            // Check the flags present in value
+            StringVector flags = SplitString(value, "|");
+            for (const auto& flag : flags)
             {
-                std::string::size_type cur_lev;
-                std::string::size_type next_lev = equal;
-                do
+                // Handle wild cards
+                if (flag == "*" || flag == "**")
                 {
-                    cur_lev = next_lev + 1;
-                    next_lev = tmp.find('|', cur_lev);
-                    std::string lev = tmp.substr(cur_lev, next_lev - cur_lev);
-                    if (lev == "error" || lev == "warn" || lev == "debug" || lev == "info" ||
-                        lev == "function" || lev == "logic" || lev == "all" ||
-                        lev == "prefix_func" || lev == "func" || lev == "prefix_time" ||
-                        lev == "time" || lev == "prefix_node" || lev == "node" ||
-                        lev == "prefix_level" || lev == "level" || lev == "prefix_all" ||
-                        lev == "level_error" || lev == "level_warn" || lev == "level_debug" ||
-                        lev == "level_info" || lev == "level_function" || lev == "level_logic" ||
-                        lev == "level_all" || lev == "*" || lev == "**")
-                    {
-                        continue;
-                    }
-                    else
-                    {
-                        NS_FATAL_ERROR("Invalid log level \""
-                                       << lev << "\" in env variable NS_LOG for component name "
-                                       << component);
-                    }
-                } while (next_lev != std::string::npos);
-            }
-            else
-            {
-                LogComponentPrintList();
-                NS_FATAL_ERROR(
-                    "Invalid or unregistered component name \""
-                    << component
-                    << "\" in env variable NS_LOG, see above for a list of valid components");
-            }
-        }
-        cur = next + 1; // parse next component
-    }
+                    continue;
+                }
+                bool ok = LOG_LABEL_LEVELS.find(flag) != LOG_LABEL_LEVELS.end();
+                if (!ok)
+                {
+                    NS_FATAL_ERROR("Invalid log level \""
+                                   << flag << "\" in env variable NS_LOG for component name "
+                                   << component);
+                }
+            } // for flag
+        }     // !value.empty
+    }         // for component
 }
 
 void
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/core/model/log.h ns-3.38/src/core/model/log.h
--- ns-3.37/src/core/model/log.h	2022-11-01 17:37:24.471395000 -0700
+++ ns-3.38/src/core/model/log.h	2023-03-16 20:54:23.592868600 -0700
@@ -134,7 +134,7 @@
  * \param [in] name The log component name.
  * \param [in] level The logging level.
  */
-void LogComponentEnable(const char* name, enum LogLevel level);
+void LogComponentEnable(const std::string& name, LogLevel level);
 
 /**
  * Enable the logging output for all registered log components.
@@ -144,7 +144,7 @@
  *
  * \param [in] level The logging level.
  */
-void LogComponentEnableAll(enum LogLevel level);
+void LogComponentEnableAll(LogLevel level);
 
 /**
  * Disable the logging output associated with that log component.
@@ -155,14 +155,14 @@
  * \param [in] name The log component name.
  * \param [in] level The logging level.
  */
-void LogComponentDisable(const char* name, enum LogLevel level);
+void LogComponentDisable(const std::string& name, LogLevel level);
 
 /**
  * Disable all logging for all components.
  *
  * \param [in] level The logging level.
  */
-void LogComponentDisableAll(enum LogLevel level);
+void LogComponentDisableAll(LogLevel level);
 
 } // namespace ns3
 
@@ -336,16 +336,14 @@
      *                  a log level helps prevent recursion by logging in
      *                  functions which help implement the logging facility.
      */
-    LogComponent(const std::string& name,
-                 const std::string& file,
-                 const enum LogLevel mask = LOG_NONE);
+    LogComponent(const std::string& name, const std::string& file, const LogLevel mask = LOG_NONE);
     /**
      * Check if this LogComponent is enabled for \c level
      *
      * \param [in] level The level to check for.
      * \return \c true if we are enabled at \c level.
      */
-    bool IsEnabled(const enum LogLevel level) const;
+    bool IsEnabled(const LogLevel level) const;
     /**
      * Check if all levels are disabled.
      *
@@ -357,19 +355,19 @@
      *
      * \param [in] level The LogLevel to enable.
      */
-    void Enable(const enum LogLevel level);
+    void Enable(const LogLevel level);
     /**
      * Disable logging at \c level for this LogComponent.
      *
      * \param [in] level The LogLevel to disable.
      */
-    void Disable(const enum LogLevel level);
+    void Disable(const LogLevel level);
     /**
      * Get the name of this LogComponent.
      *
      * \return The name of this LogComponent.
      */
-    const char* Name() const;
+    std::string Name() const;
     /**
      * Get the compilation unit defining this LogComponent.
      * \returns The file name.
@@ -381,13 +379,13 @@
      * \param [in] level The LogLevel to get the label for.
      * \return The string label for \c level.
      */
-    static std::string GetLevelLabel(const enum LogLevel level);
+    static std::string GetLevelLabel(const LogLevel level);
     /**
      * Prevent the enabling of a specific LogLevel.
      *
      * \param [in] level The LogLevel to block.
      */
-    void SetMask(const enum LogLevel level);
+    void SetMask(const LogLevel level);
 
     /**
      * LogComponent name map.
@@ -400,7 +398,7 @@
     typedef std::map<std::string, LogComponent*> ComponentList;
 
     /**
-     * Get the list of LogComponnents.
+     * Get the list of LogComponents.
      *
      * \internal
      * This should really be considered an internal API.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/core/model/map-scheduler.cc ns-3.38/src/core/model/map-scheduler.cc
--- ns-3.37/src/core/model/map-scheduler.cc	2022-11-01 17:37:24.471395000 -0700
+++ ns-3.38/src/core/model/map-scheduler.cc	2023-03-16 20:54:23.592868600 -0700
@@ -85,7 +85,7 @@
     Event ev;
     ev.impl = i->second;
     ev.key = i->first;
-    NS_LOG_DEBUG(this << ev.impl << ev.key.m_ts << ev.key.m_uid);
+    NS_LOG_DEBUG(this << ": " << ev.impl << ", " << ev.key.m_ts << ", " << ev.key.m_uid);
     return ev;
 }
 
@@ -99,7 +99,7 @@
     ev.impl = i->second;
     ev.key = i->first;
     m_list.erase(i);
-    NS_LOG_DEBUG(this << ev.impl << ev.key.m_ts << ev.key.m_uid);
+    NS_LOG_DEBUG("@" << this << ": " << ev.impl << ", " << ev.key.m_ts << ", " << ev.key.m_uid);
     return ev;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/core/model/matrix-array.cc ns-3.38/src/core/model/matrix-array.cc
--- ns-3.37/src/core/model/matrix-array.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.38/src/core/model/matrix-array.cc	2023-03-16 20:54:23.592868600 -0700
@@ -0,0 +1,236 @@
+/*
+ * Copyright (c) 2022 Centre Tecnologic de Telecomunicacions de Catalunya (CTTC)
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Biljana Bojovic <bbojovic@cttc.es>
+ */
+
+#include "matrix-array.h"
+
+#ifdef HAVE_EIGEN3
+#include <Eigen/Dense>
+#endif
+
+namespace ns3
+{
+
+#ifdef HAVE_EIGEN3
+template <class T>
+using EigenMatrix = Eigen::Map<Eigen::Matrix<T, Eigen::Dynamic, Eigen::Dynamic>>;
+template <class T>
+using ConstEigenMatrix = Eigen::Map<const Eigen::Matrix<T, Eigen::Dynamic, Eigen::Dynamic>>;
+#endif
+
+template <class T>
+MatrixArray<T>::MatrixArray(uint16_t numRows, uint16_t numCols, uint16_t numPages)
+    : ValArray<T>(numRows, numCols, numPages)
+{
+}
+
+template <class T>
+MatrixArray<T>::MatrixArray(const std::valarray<T>& values)
+    : ValArray<T>(values)
+{
+}
+
+template <class T>
+MatrixArray<T>::MatrixArray(std::valarray<T>&& values)
+    : ValArray<T>(std::move(values))
+{
+}
+
+template <class T>
+MatrixArray<T>::MatrixArray(const std::vector<T>& values)
+    : ValArray<T>(values)
+{
+}
+
+template <class T>
+MatrixArray<T>::MatrixArray(uint16_t numRows, uint16_t numCols, const std::valarray<T>& values)
+    : ValArray<T>(numRows, numCols, values)
+{
+}
+
+template <class T>
+MatrixArray<T>::MatrixArray(uint16_t numRows, uint16_t numCols, std::valarray<T>&& values)
+    : ValArray<T>(numRows, numCols, std::move(values))
+{
+}
+
+template <class T>
+MatrixArray<T>::MatrixArray(uint16_t numRows,
+                            uint16_t numCols,
+                            uint16_t numPages,
+                            const std::valarray<T>& values)
+    : ValArray<T>(numRows, numCols, numPages, values)
+{
+}
+
+template <class T>
+MatrixArray<T>::MatrixArray(uint16_t numRows,
+                            uint16_t numCols,
+                            uint16_t numPages,
+                            std::valarray<T>&& values)
+    : ValArray<T>(numRows, numCols, numPages, std::move(values))
+{
+}
+
+template <class T>
+MatrixArray<T>
+MatrixArray<T>::operator*(const MatrixArray<T>& rhs) const
+{
+    NS_ASSERT_MSG(m_numPages == rhs.m_numPages, "MatrixArrays have different numbers of matrices.");
+    NS_ASSERT_MSG(m_numCols == rhs.m_numRows, "Inner dimensions of matrices mismatch.");
+
+    MatrixArray<T> res{m_numRows, rhs.m_numCols, m_numPages};
+
+    for (uint16_t page = 0; page < res.m_numPages; ++page)
+    {
+#ifdef HAVE_EIGEN3 // Eigen found and enabled Eigen optimizations
+
+        ConstEigenMatrix<T> lhsEigenMatrix(GetPagePtr(page), m_numRows, m_numCols);
+        ConstEigenMatrix<T> rhsEigenMatrix(rhs.GetPagePtr(page), rhs.m_numRows, rhs.m_numCols);
+        EigenMatrix<T> resEigenMatrix(res.GetPagePtr(page), res.m_numRows, res.m_numCols);
+        resEigenMatrix = lhsEigenMatrix * rhsEigenMatrix;
+
+#else // Eigen not found or Eigen optimizations not enabled
+
+        size_t matrixOffset = page * m_numRows * m_numCols;
+        for (uint16_t i = 0; i < res.m_numRows; ++i)
+        {
+            for (uint16_t j = 0; j < res.m_numCols; ++j)
+            {
+                res(i, j, page) =
+                    (m_values[std::slice(matrixOffset + i, m_numCols, m_numRows)] *
+                     rhs.m_values[std::slice(matrixOffset + j * rhs.m_numRows, rhs.m_numRows, 1)])
+                        .sum();
+            }
+        }
+
+#endif
+    }
+    return res;
+}
+
+template <class T>
+MatrixArray<T>
+MatrixArray<T>::Transpose() const
+{
+    // Create the matrix where m_numRows = this.m_numCols, m_numCols = this.m_numRows,
+    // m_numPages = this.m_numPages
+    MatrixArray<T> res{m_numCols, m_numRows, m_numPages};
+
+    for (uint16_t page = 0; page < m_numPages; ++page)
+    {
+#ifdef HAVE_EIGEN3 // Eigen found and Eigen optimizations enabled
+
+        ConstEigenMatrix<T> thisMatrix(GetPagePtr(page), m_numRows, m_numCols);
+        EigenMatrix<T> resEigenMatrix(res.GetPagePtr(page), res.m_numRows, res.m_numCols);
+        resEigenMatrix = thisMatrix.transpose();
+
+#else // Eigen not found or Eigen optimizations not enabled
+
+        size_t matrixIndex = page * m_numRows * m_numCols;
+        for (uint16_t i = 0; i < m_numRows; ++i)
+        {
+            res.m_values[std::slice(matrixIndex + i * res.m_numRows, res.m_numRows, 1)] =
+                m_values[std::slice(matrixIndex + i, m_numCols, m_numRows)];
+        }
+
+#endif
+    }
+    return res;
+}
+
+template <class T>
+MatrixArray<T>
+MatrixArray<T>::MultiplyByLeftAndRightMatrix(const MatrixArray<T>& lMatrix,
+                                             const MatrixArray<T>& rMatrix) const
+{
+    NS_ASSERT_MSG(lMatrix.m_numPages == 1 && rMatrix.m_numPages == 1,
+                  "The left and right MatrixArray should have only one page.");
+    NS_ASSERT_MSG(lMatrix.m_numCols == m_numRows,
+                  "Left vector numCols and this MatrixArray numRows mismatch.");
+    NS_ASSERT_MSG(m_numCols == rMatrix.m_numRows,
+                  "Right vector numRows and this MatrixArray numCols mismatch.");
+
+    MatrixArray<T> res{lMatrix.m_numRows, rMatrix.m_numCols, m_numPages};
+
+#ifdef HAVE_EIGEN3
+
+    ConstEigenMatrix<T> lMatrixEigen(lMatrix.GetPagePtr(0), lMatrix.m_numRows, lMatrix.m_numCols);
+    ConstEigenMatrix<T> rMatrixEigen(rMatrix.GetPagePtr(0), rMatrix.m_numRows, rMatrix.m_numCols);
+#endif
+
+    for (uint16_t page = 0; page < m_numPages; ++page)
+    {
+#ifdef HAVE_EIGEN3 // Eigen found and Eigen optimizations enabled
+
+        ConstEigenMatrix<T> matrixEigen(GetPagePtr(page), m_numRows, m_numCols);
+        EigenMatrix<T> resEigenMap(res.GetPagePtr(page), res.m_numRows, res.m_numCols);
+
+        resEigenMap = lMatrixEigen * matrixEigen * rMatrixEigen;
+
+#else // Eigen not found or Eigen optimizations not enabled
+
+        size_t matrixOffset = page * m_numRows * m_numCols;
+        for (uint16_t resRow = 0; resRow < res.m_numRows; ++resRow)
+        {
+            for (uint16_t resCol = 0; resCol < res.m_numCols; ++resCol)
+            {
+                // create intermediate row result, a multiply of resRow row of lMatrix and each
+                // column of this matrix
+                std::valarray<T> interRes(m_numCols);
+                for (uint16_t thisCol = 0; thisCol < m_numCols; ++thisCol)
+                {
+                    interRes[thisCol] =
+                        (lMatrix
+                             .m_values[std::slice(resRow, lMatrix.m_numCols, lMatrix.m_numRows)] *
+                         m_values[std::slice(matrixOffset + thisCol * m_numRows, m_numRows, 1)])
+                            .sum();
+                }
+                // multiply intermediate results and resCol column of the rMatrix
+                res(resRow, resCol, page) =
+                    (interRes *
+                     rMatrix.m_values[std::slice(resCol * rMatrix.m_numRows, rMatrix.m_numRows, 1)])
+                        .sum();
+            }
+        }
+#endif
+    }
+    return res;
+}
+
+template <class T>
+template <bool EnableBool, typename>
+MatrixArray<T>
+MatrixArray<T>::HermitianTranspose() const
+{
+    MatrixArray<std::complex<double>> retMatrix = this->Transpose();
+
+    for (size_t index = 0; index < this->GetSize(); ++index)
+    {
+        retMatrix[index] = std::conj(m_values[index]);
+    }
+    return retMatrix;
+}
+
+template MatrixArray<std::complex<double>> MatrixArray<std::complex<double>>::HermitianTranspose()
+    const;
+template class MatrixArray<std::complex<double>>;
+template class MatrixArray<double>;
+template class MatrixArray<int>;
+
+} // namespace ns3
